service_2_archive/archive/urls.py
from django.conf.urls import url
from django.views.generic.base import RedirectView
from .views import *
#url for app
app_name = 'archive'

urlpatterns = [
    url(r'^$', RedirectView.as_view(url='archive/', permanent = False), name='$'),
    url(r'archive/', archive, name='archive'),
    url(r'auth_login/', auth_login, name='auth_login'),
    url(r'^download/(?P<path>.*)$', download, name='download'),
]

service_2_archive/service_2_archive/urls.py
from django.contrib import admin
from django.urls import path, include
import archive.urls as archive

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(archive, namespace='archive')),
]

service_2_archive/archive/models.py
from django.db import models

class FileModel(models.Model):
    name = models.CharField(max_length=255)
    upload = models.FileField(upload_to ='uploads/')

service_2_archive/archive/forms.py
from django import forms

class FileForm(forms.Form):
    file = forms.FileField() # for creating file input  

service_2_archive/archive/views.py
from django.conf import settings
from django.http import FileResponse, Http404
from django.shortcuts import render
from .auth_utils import ambil_token, ambil_resource
from .forms import FileForm
from .models import FileModel

import os

def archive(request):
    response = {}
    if not request.session.get('access_token'):
        return render(request, 'login.html', response)
    resp = ambil_resource(request.session.get('access_token'))
    json_response = resp.json()
    if 'error' in json_response:
        response['expired'] = "expired"
        return render(request, 'login.html', response)
    if request.POST:
        fileForm = FileForm(request.POST, request.FILES)
        if fileForm.is_valid:
            file = request.FILES['file']
            fileName = request.FILES['file'].name
            handle_uploaded_file(request.FILES['file'], fileName)
        else:
            response['error'] = "error"
    models = FileModel.objects.all().order_by('-id').values('id', 'name', 'upload')
    response['files'] = models
    fileForm = FileForm()
    response['form'] = fileForm
    return render(request, 'archive.html', response)

def download(request, path):
    file_path = os.path.join(settings.MEDIA_ROOT, path)
    if os.path.exists(file_path):
        file = open(file_path, 'rb')
        return FileResponse(file)
    raise Http404

def handle_uploaded_file(f, name):
    model = FileModel(name=name, upload=f)
    model.save()

def auth_login(request):
    response = {}
    if request.POST:
        username = request.POST['username']
        password = request.POST['password']
        resp = ambil_token(username, password, 'oSheev1Woh0OhFieza5ud1ahm9xooNgiuxaefaok', 'Tiongoh1phi0hithai6meiz4aj5roo8Boh0eeb6a')
        json_response = resp.json()
        if 'error' in json_response:
            response['error'] = "error"
            return render(request, 'login.html', response)
        access_token = json_response['access_token']
        request.session['access_token'] = access_token
        models = FileModel.objects.all().order_by('-id').values('id', 'name', 'upload')
        response['files'] = models
        fileForm = FileForm()
        response['form'] = fileForm
        return render(request, 'archive.html', response)

service_2_archive/templates/archive.html
{% extends "base.html" %}
{% load static %}
{% block css %}
<style type="text/css">
  .center {
    align-items: center;
    text-align: center;
    margin: auto;
  }
  .margin-top-20 {
    margin-top: 20px;
  }
  .margin-bottom-10 {
    margin-bottom: 10px;
  }
</style>
{% endblock %}

{% block content %}
<section name="container" class="content">
  <h2>File Upload</h2>
  <form id="form" name="form" method="POST" action="{% url 'archive:archive' %}" enctype="multipart/form-data">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit">Submit</button>
  </form>

  {% if error %}
    <h3>TERDAPAT ERROR PROCESSING FILE</h3>
  {% else %}
  {% endif %}

  <div class="files-section">
    <div class="center margin-top-20 margin-bottom-10">
      <h2>FILE LIST</h2>
    </div>
    <table class="table table-dark">
      <thead>
        <tr>
          <th scope="col">#</th>
          <th scope="col">Name</th>
          <th scope="col">Url</th>
        </tr>
      </thead>
      <tbody>
        {% for file in files %}
        <tr>
          <th scope="row">{{ forloop.counter }}</th>
          <td>{{ file.name }}</td>
          <td><a href="/download/{{ file.upload }}" download>Download</a></td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</section>
{% endblock %}

{% block javascript %}
{% endblock %}

service_2_archive/templates/base.html
{% load static %}
<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="theme-color" content="#342345">
  <title> {% block title %} Service 2 of LAW_KEMAS {% endblock %}</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
  <link href='https://fonts.googleapis.com/css?family=Raleway:900|Raleway' rel='stylesheet'>
  <meta name="viewport" content="initial-scale=1.0, width=device-width" />

  {% block css %}
      
  {% endblock %}
</head>

<body>
  <div class="se-pre-con"></div>
  <header>
  <!-- navbar -->
  {% block header %}
  {% endblock %}
</header>
<content>
  <!-- content -->

    {% block content %}
    {% endblock %}
 
</content>
<footer>
  {% block footer %}
  {% endblock %}
</footer>

  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
  {% block javascript %}
  {% endblock %}
</body>

</html>

service_2_archive/templates/login.html
{% extends "base.html" %}
{% load static %}
{% block css %}
{% endblock %}

{% block content %}
<section name="container" class="content">
  <h2>LOG IN</h2>
  <form id="form" name="form" method="POST" action="{% url 'archive:auth_login' %}" enctype="multipart/form-data">
    {% csrf_token %}
    <input type="text" name="username" placeholder="username">
    <input type="password" name="password" placeholder="password">
    <button type="submit">Submit</button>
  </form>

  {% if error %}
    <h3>Wrong username or password</h3>
  {% elif expired %}
    <h3>Session has expired, please login again</h3>
  {% endif %}

</section>
{% endblock %}

{% block javascript %}
{% endblock %}